﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MrAG {
    public partial class Gui {
        public class Label : Base {
            public string Text = "";

            public SpriteFont Font = MrAG.Draw.Font;

            public Color Color = Color.White;

            public MrAG.Draw.TextAlignmentX AlignmentX = MrAG.Draw.TextAlignmentX.Left;
            public MrAG.Draw.TextAlignmentY AlignmentY = MrAG.Draw.TextAlignmentY.Top;
            public float Rotation = 0;


            public override void Draw() {
                MrAG.Draw.SetFont(this.Font);
                MrAG.Draw.Text(this.Text, this.X, this.Y, this.Color, this.AlignmentX, this.AlignmentY, this.Rotation);
                
                base.Draw();
            }
        }
    }
}
